/* Note to Hong: This is the most recent version of EEB_JavaThread */
import java.net.*;
import java.io.*;


public class EEB_JavaThread extends Thread {
    
    protected int portnumber = 1000;
    protected DatagramSocket MainSocket = null;
    
    String line = "100";
    String line2 = "0.5";
    String line3 = "-0.2";
    
    int N = 0;
    
    double x_old_1=0;
    double x_old_2=0;
    
    double x_new_1=0;
    double x_new_2=0;
    double h = 0.1;
    double a = 5;
    
    /** Creates a new instance of EEB_JavaThread */
    public EEB_JavaThread() throws IOException{
        this("EEB_JavaThread");
    }
    
    public EEB_JavaThread(String name) throws IOException {
        super(name);
        MainSocket = new DatagramSocket(portnumber);
    }
    
    public static double convert_degrees(double test) {

        double x = (double)test;
        double y;
        double m = 180.0/2047.0;
        
        
        x = (double)test;
        if (x <= 2047.0) {
            y = -m*x + 180.0;
        } else {
            y = -m*x + 540.0;
        }
        //System.out.println(y);
        return y;

    }
    
    public static int unsignedBytesToShort(byte[] baValue, int numBytes) {
        int value = 0;
        for(int i = 0; i < numBytes; i++) {
            int b = baValue[numBytes-i-1];
            if (b<0) {
                b+=256;
            }
            value |= (b << (i*8));
        }
        return value;
    }
    
    public void run() {
        
        boolean flag = true;
        byte t1;
        byte t2;
        byte t3;
        byte t4;   
        byte t5;
        byte t6;
        int position;
        int Sample;
        int out_voltage;
        int Pgain;
        int Dgain;
       
        double temp = 100;
        double temp2 = 1;
        double temp3 = 1;
        //int out_voltage;
        
        
        byte[] bs2 = new byte[]{(byte)128, (byte)238, (byte)129, (byte)91};
        int port = 1000;
        
        byte[] tempA = new byte[3];
        
        
        while (flag) {
            try {
                
                             
                InetAddress bs2address = InetAddress.getByAddress(bs2);
                byte[] buf = new byte[6];
              
                byte[] incoming = new byte[14];
                
                // Starts a new DatagramPacket and tries and starts receiving data
                DatagramPacket MainPacket = new DatagramPacket(buf,buf.length);
                
                    
                //System.out.println("BSp2");
                //here is where u will read the value fomr the file
                
                try {
                    BufferedReader in = new BufferedReader(new FileReader("c:\\send.txt"));
                    line = in.readLine();
                    line2 = in.readLine();
                    line3 = in.readLine();
                    in.close();
                }catch (IOException e) {
                    line = "180";
                    line2 = "0.5";
                     line3 = "0.2";
                }
                    
                if (line == null) {
                   line = "180"; 
                }
                if (line2 == null) {
                   line2 = "0.5"; 
                }                
                if (line3 == null) {
                   line3 = "-0.2";
                }                
                
                    
                //System.out.println("value in file: ");
                //System.out.println("Angle " + line);
                //System.out.println("P-gain " + line2);
                //System.out.println("D-gain " + line3);
                
                try {temp = Double.parseDouble(line);} catch (NumberFormatException e) { temp = 100;};
                try {temp2 = Double.parseDouble(line2);} catch (NumberFormatException e) { temp2 = 0.5;};
                try { temp3 = Double.parseDouble(line3);} catch (NumberFormatException e) { temp3 = 0.4;};
                
               
                
                   
                //out_voltage = 180;
                out_voltage = (int)temp;
                temp2 = temp2*10;
                temp3 = temp3*(-10);
                Pgain = (int)temp2;
                Dgain = (int)temp3;
                               
                                 
                //System.out.println("out_voltage ");
                //System.out.println(out_voltage);
                    
                    
                buf[0] = (byte)111;
                //buf[1] = (byte)Pgain;  //you can use this byte for sequnce
                buf[1] = (byte)111;  //you can use this byte for sequnce
                    
                //System.out.println("Pgain is");
                //System.out.println(Pgain);
                                      
                if (out_voltage <= 255) {
                    buf[2] = 0;
                    buf[3] = (byte)out_voltage;
                }
                    
                if (out_voltage > 255) {
                    buf[2] = (byte)1;
                    buf[3] = (byte)(out_voltage-256);
                }

                // For the first time, send the following command
                if (N==0) {
                    buf[2] = (byte)255;
                    buf[3] = (byte)255;
                    N = N+1;
                }
                
                //System.out.println(buf[2]);
                  
                buf[4] = (byte)Pgain;
                buf[5] = (byte)Dgain;
                                
                // Sends the buffered data back to the sender
                    
                //System.out.println("just before sending");
                MainPacket = new DatagramPacket(buf, buf.length, bs2address, port);
                MainSocket.send(MainPacket);
                //System.out.println("just sent");

                
                try {
                    MainSocket.setSoTimeout(4000);
                    MainSocket.receive(MainPacket);
                } catch (SocketTimeoutException e) { 
                    Sample = -100;
                };
                
                // Receives data in the form of a String
                incoming = MainPacket.getData();
                
                /*t1 = incoming[0]; //will hold bit with value 256
                t2 = incoming[1];
                t3 = incoming[2]; //will hold bit with value 256
                t4 = incoming[3];
                t5 = incoming[4];
                t6 = incoming[5];
                */
                
                
                tempA[0] = incoming[0];
                tempA[1] = incoming[1];
                
                double angle1 = (double)unsignedBytesToShort(tempA,2);
                
                double ang1 = convert_degrees(angle1);
                
                System.out.println(angle1);
                

                tempA[0] = incoming[2];
                tempA[1] = incoming[3];
                
                double angle2 = (double)unsignedBytesToShort(tempA,2);
                
                double ang2 = convert_degrees(angle2);
                
                //System.out.println(angle2);
                
                tempA[0] = incoming[4];
                tempA[1] = incoming[5];
                
                Sample = unsignedBytesToShort(tempA,2);
                
                
                //x_old_1 = ang1;
                
                x_new_1 = x_old_2 - a*x_old_2*h + a*ang1*h;
                
                x_old_1 = x_new_1;
                
                x_new_2 = x_old_1 - a*x_old_1*h + a*ang2*h;
                
                x_old_2 = x_new_2;
                
                          
                //line = Double.toString(ang1);
                line = Double.toString(x_new_1);
                //line2 = Double.toString(ang2);
                line2 = Double.toString(x_new_2);
                line3 = Double.toString(Sample);    
                //System.out.println(line2);
                //System.out.println(tempA);
                System.out.println(x_new_2);
                //System.out.println(Sample);
                try {
                    PrintWriter wrtr = new PrintWriter(new BufferedWriter(new FileWriter("c:\\plot.txt")));
                     wrtr.println(line);
                     wrtr.println(line2);
                     wrtr.println(line3);
                     wrtr.close();
                    } catch (IOException e) {System.out.println("WRITE FAILED");}
                
                //System.out.println("after write ");
                
            } catch (IOException e) {
                e.printStackTrace();
                //System.out.println("ERROR");
                flag = false;
            }
        }
        MainSocket.close();
    }
    
}